@REM This script adds the root certificate authority for Imatest's SSL certificate to 
@REM JRE certificate store within the MATLAB Runtime

@echo off

:: BatchGotAdmin
:-------------------------------------
REM  --> Check for permissions
    IF "%PROCESSOR_ARCHITECTURE%" EQU "amd64" (
>nul 2>&1 "%SYSTEMROOT%\SysWOW64\cacls.exe" "%SYSTEMROOT%\SysWOW64\config\system"
) ELSE (
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"
)

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params= %*
    echo UAC.ShellExecute "cmd.exe", "/c ""%~s0"" %params:"=""%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    del "%temp%\getadmin.vbs"
    exit /B

:gotAdmin
    pushd "%CD%"
    CD /D "%~dp0"
:-------------------------------------- 

@REM Prepare the system PATH environment variable
@set SCRIPT_PATH=%~dp0
@set OLD_PATH=%PATH%
@set CERT_FILE_PATH=%SCRIPT_PATH%imatest_ssl_cert.cer
@set LOG_FILE=%SCRIPT_PATH%jre_cert_store_update.log

@echo off
call :update "%PROGRAMFILES%\MATLAB\MATLAB Runtime" win64 "%CERT_FILE_PATH%" "%LOG_FILE%"
call :update "%PROGRAMFILES%\MATLAB\MATLAB Compiler Runtime" win64 "%CERT_FILE_PATH%" "%LOG_FILE%"
call :update "%PROGRAMFILES(X86)%\MATLAB\MATLAB Runtime" win32 "%CERT_FILE_PATH%" "%LOG_FILE%"
call :update "%PROGRAMFILES(X86)%\MATLAB\MATLAB Compiler Runtime" win32 "%CERT_FILE_PATH%" "%LOG_FILE%"
@echo on
@echo Done
@set PATH=%OLD_PATH%
@goto :eof



:: FUNCTION update
:: %1 - MATLAB Runtime folder path
:: %2 - Architecture folder (win32 or win64)
:: %3 - ssl certificate file path
:: %4 - output logfile path

:update
@setlocal ENABLEDELAYEDEXPANSION
set MATLAB_PATH=%1
set ARCH=%2
set CERT_FILE_PATH=%3
set LOG_FILE=%4
if exist %MATLAB_PATH% (
	@for /f "tokens=*" %%G in ('dir /b /a:d %MATLAB_PATH%\v*') do (
		@set MCR_ROOT=!MATLAB_PATH!\%%G
		@set MCR_ROOT="!MCR_ROOT:"=!"
		
		@echo Updating certificate store for !MCR_ROOT! >> "%LOG_FILE%"
		@set CERT_STORE_PATH=!MCR_ROOT!\sys\java\jre\!ARCH!\jre\lib\security\cacerts
		@set CERT_STORE_PATH="!CERT_STORE_PATH:"=!"
		
		@echo Certificate store path !CERT_STORE_PATH! >> "%LOG_FILE%"
		@set JRE_BIN="!MCR_ROOT!\sys\java\jre\!ARCH!\jre\bin\"
		@set JRE_LIB="!MCR_ROOT!\sys\java\jre\!ARCH!\jre\"
		@set JRE_BIN=!JRE_BIN:"=!
		@set JRE_LIB=!JRE_LIB:"=!
		@set PATH=!JRE_BIN!;!JRE_LIB!;!OLD_PATH!

		@set KEYTOOL=!JRE_BIN!keytool.exe
		@set KEYTOOL=!KEYTOOL:"=!
		
		@start "" /B /W "!KEYTOOL!" -import -noprompt -trustcacerts -alias imatest -file !CERT_FILE_PATH! -keystore !CERT_STORE_PATH! -storepass changeit  >> %LOG_FILE%
		@echo. >> %LOG_FILE%
	)
)
@endlocal
@exit /B

